open Terme
open Instructions

let rec compile = function
 | Var s -> [IVar s]
 | Const c -> [IConst c]
 | Op  s -> [IOp s]
 | App (t1, t2) -> (compile t1)@(compile t2)@[IApp]
 | Fun (x, t) ->  [IClos(x,(compile t)@[IRet])]
 | Let (x,t1,t2) -> (compile t1)@[ILet x]@(compile t2)@[IEndLet x]


let _ =
 let lexbuf = Lexing.from_channel stdin in
 let expr = ParserTerm.expression LexerTerm.token lexbuf in
 let prog = compile expr in
   print_string (Instructions.to_string prog);
   print_newline(); 
   flush stdout
