type instruction = 
    IVar of string
  | IConst of int
  | IOp of string  
  | IClos of string * (instruction list)
  | ILet of string
  | IEndLet of string
  | IApp
  | IRet


let rec instr_to_string = function
  | IVar s -> "VAR("^s^")"
  | IApp   -> "APP"
  | IRet   -> "RET"
  | IConst c -> "CONST("^(string_of_int c)^")"
  | IOp c -> "OP("^c^")"
  | ILet s -> "LET("^s^")"
  | IEndLet s -> "EndLET("^s^")"
  | IClos (x,t) -> "CLOS("^x^","^(to_string t)^")"
 and
  to_string t = List.fold_left (fun s1 s2 -> s1^s2^";") "" (List.map instr_to_string t) 
