(* Un analyseur lexical pour la petite VM *)

{ open ParserInstr }
 
let digit = ['0'-'9']
let letter = ['a'-'z' 'A'-'Z']
let ident = letter (digit|letter|'_')*
let nombre =  '-'? digit
 
rule token = parse
  | ","         { COMMA }
  | ';'         { SEPA }
  | "("         { LPAREN }
  | ")"         { RPAREN }
  | "CONST"     { CONST }
  | "VAR"       { VAR }
  | "APP"       { APP }
  | "RET"       { RET }
  | "OP"        { OP }
  | "LET"       { LET }
  | "EndLET"    { EndLET }
  | "CLOS"      { CLOS }  
  | ident as i  { IDENT i }
  | nombre as n { INT(int_of_string n) }  
  | eof         { EOF }
  | _           { token lexbuf }

