(* Un analyseur lexical pour mini-ML *)

{
open ParserTerm

let operateurs = ["incr";"fst"; "snd";]
}

rule token = parse
    [' ' '\010' '\013' '\009' '\012'] +
      { token lexbuf }
  | '-'? ['0'-'9']+
      { INT(int_of_string(Lexing.lexeme lexbuf)) }
(*  | "," { COMMA } *) (* Pour rajouter des pairs *)
  | "fun" { FUN }
  | "->" { ARROW }
  | "let" { LET }
  | "=" { EQUAL }
  | "in" { IN }
  | "(" { LPAREN }
  | ")" { RPAREN }
  | ['A'-'Z' 'a'-'z' '_'] ['A'-'Z' 'a'-'z' '0'-'9' '_'] *
      { let s = Lexing.lexeme lexbuf in
        if List.mem s operateurs then OP s else IDENT s }
(*  | ['!' '$' '%' '&' '*' '+' '-' '.' '/' ':' '<' '=' '>' '?' '@' '^' '|' '~'] +
      { OP(Lexing.lexeme lexbuf) } *)
  | eof { EOF }
