/* Un analyseur syntaxique pour les instructions machines */

%{
  open Instructions
%}
 
%token CONST VAR APP RET OP LET EndLET CLOS
%token EOF SEPA LPAREN RPAREN COMMA
%token <string> IDENT
%token <int> INT
 
%start program
%type <Instructions.instruction list> program
%type <Instructions.instruction list> corpFun

%%
 
program:
 | instruction SEPA program { $1 :: $3 }
 | EOF { [] }

corpFun:
 | instruction SEPA corpFun { $1 :: $3 }
 | { [] }

 
instruction:
 | CONST LPAREN INT RPAREN { Instructions.IConst($3)}
 | APP {Instructions.IApp}
 | RET {Instructions.IRet}
 | VAR LPAREN IDENT RPAREN {Instructions.IVar($3)}
 | OP LPAREN IDENT RPAREN {Instructions.IOp($3)}
 | LET LPAREN IDENT RPAREN {Instructions.ILet($3)}
 | EndLET LPAREN IDENT RPAREN {Instructions.IEndLet($3)}
 | CLOS LPAREN IDENT COMMA corpFun RPAREN {Instructions.IClos($3,$5)}


