/* Un analyseur syntaxique pour un mini-ML */

%{
open Terme
%}

/* Tokens */
/* %token COMMA */
%token FUN
%token ARROW
%token LET
%token EQUAL
%token IN
%token <string> IDENT
%token <string> OP
%token <int> INT
%token LPAREN
%token RPAREN
%token EOF

/* Priorits et associativits -- du moins prioritaire au plus prioritaire */
%right prec_fun
%right prec_let
/* %right COMMA */

/* Points d'entre */
%type <Terme.expression> expression
%start expression

%%

expression: expr EOF            { $1 }
;

expr:
    application                 { $1 }
/*  | expr COMMA expr             { Paire($1, $3) } */
  | FUN IDENT ARROW expr %prec prec_fun
                                { Fun($2, $4) }
  | LET IDENT EQUAL expr IN expr %prec prec_let
                                { Let($2, $4, $6) }
;

application:
    application closed_expr     { App($1, $2) }
  | closed_expr                 { $1 }
;

closed_expr:
    IDENT               { Var $1 }
  | OP                  { Op $1 }
  | INT                 { Const $1 }
  | LPAREN expr RPAREN  { $2 }
;
